// closed.mod
// Model: Ireland (2004), Review of Economic and Statistics.
// Used by: Kulish and Jones, 'A Graphical Representation of an Estimated DSGE Model'

var a e z x ppihat yhat ghat rhat ast adt Eppihat Ex 
 astppihat astyhat astz asta aste adtx adtppihat adtyhat adtrhat adtz adta adteps_r;

varexo eps_a eps_e eps_z eps_r;

parameters beta, rho_a, rho_e, omega, psi, rho_pi, rho_g, rho_x;

beta = 0.99;//0.99778008315;
psi = 0.1;//0.9
omega = 0.0617;

model;
a = rho_a*a(-1) + eps_a ;
e = rho_e*e(-1) + eps_e ;
z = eps_z ;
x = x(+1) - rhat + ppihat(+1) + (1-omega)*(1-rho_a)*a ;
ppihat = beta*ppihat(+1) + psi*x - e ;
x = yhat - omega*a ;
ghat = yhat - yhat(-1) + z ;
rhat = rhat(-1) + rho_pi*ppihat + rho_g*ghat + rho_x*x + eps_r ;
// Equations for the shifters (without constants)
ast = beta*ppihat(+1) + psi*yhat(-1) - psi*z - omega*psi*a - e ;
astppihat = beta*ppihat(+1);
astyhat = psi*yhat(-1);
astz = -psi*z;
asta = -omega*psi*a;
aste = -e;
adt = (1/rho_pi)*x(+1) + (1/rho_pi)*ppihat(+1) - ((1+rho_x)/rho_pi)*yhat(-1) 
      -(1/rho_pi)*rhat(-1) + ((1+rho_x)/rho_pi)*z + ((omega*(1+rho_x)+(1-omega)*(1-rho_a))/rho_pi)*a
      -(1/rho_pi)*eps_r ;
adtx = (1/rho_pi)*x(+1);
adtppihat = (1/rho_pi)*ppihat(+1);
adtyhat = - ((1+rho_x)/rho_pi)*yhat(-1);
adtrhat = -(1/rho_pi)*rhat(-1);
adtz = ((1+rho_x)/rho_pi)*z;
adta = ((omega*(1+rho_x)+(1-omega)*(1-rho_a))/rho_pi)*a;
adteps_r = -(1/rho_pi)*eps_r;
// Dummy equations for conditional expectations
Eppihat = ppihat(+1);
Ex = x(+1);
end;

estimated_params;
rho_a, 0.9470, 0, 1 ;
rho_e, 0.9625, 0, 1 ;
//omega, 0.0617, 0, 1 ;
rho_pi, 0.3597 ;
rho_g, 0.2536 ;
rho_x, 0.0347 ;
stderr eps_a, 0.0405, 0, 1 ;
stderr eps_e, 0.0012, 0, 1 ;
stderr eps_z, 0.0109, 0, 1 ;
stderr eps_r, 0.0031, 0, 1 ;
end;

varobs ghat ppihat rhat;

estimation(datafile=usdata);

stoch_simul(irf=200,nograph);